package com.wulfson.livescore;

import java.awt.*;
import java.awt.geom.Rectangle2D;
import java.awt.font.*;
import java.text.*;

public class LSTextBox
{
	//protected LSPage _page;
	protected Rectangle2D.Float _box;
	protected String _header;
	protected int _headerSize;
	protected AttributedString _text;
	
	public LSTextBox()
	{	
		_header = "Text:"; 
		_headerSize = 20;
	}

	public void paint(Graphics g)
	{
		AttributedCharacterIterator it;		
		LineBreakMeasurer measurer;
		TextLayout layout;
		Graphics2D g2 = (Graphics2D)g;
		float ypos;
		
		ypos=(float)_box.getMinY() + 10;
		it = _text.getIterator();
		measurer = new LineBreakMeasurer(it, g2.getFontRenderContext());		
		
		g2.setColor(Color.white);
		g2.fill(_box);
		g2.setColor(Color.black);
		g2.draw(_box);
		g.setFont(new Font("Helvetica", Font.PLAIN, _headerSize));
		if(_header != null) //could be null
		{
			g2.drawString(_header, _box.x + 10, ypos + 20);
			ypos += 30;
		}
		
		while(measurer.getPosition() < it.getEndIndex())
		{
			layout = measurer.nextLayout(_box.width - 20); //TODO margins
			ypos += layout.getAscent() + 5;
			layout.draw(g2, (float)_box.getMinX() + 10, ypos); //TODO margin=10
		}
	}

	public Rectangle2D.Float getBox()
	{
		return _box;
	}

	public void setBox(Rectangle2D.Float box)
	{
		_box = box;
	}
	
	public String getHeader()
	{
		return _header;
	}

	public void setHeader(String header)
	{
		_header = header;
	}

	
	public int getHeaderSize()
	{
		return _headerSize;
	}

	public void setHeaderSize(int headerSize)
	{
		_headerSize = headerSize;
	}

	public AttributedString getText()
	{
		return _text;
	}

	public void setText(AttributedString text)
	{
		_text = text;
	}
	
	
}
