
//Run this twice to initiate LiveScore
l=LSDifficult.new;
l=LSDifficult.new;

//Add a client by instrument name.
//Run the following three lines to connect a client. Each Client needs a different instrument, address (which will post at the top of the LS client, and index.
//Note. If you send something twice (name or address) you double the notes sent (bad bug)
//Here are a couple examples:

l.addClient(LSClient.forName("Flute")); 
l.clients.at(0).connect("192.168.15.233",57110);
l.clients.at(0).addr.sendMsg("/livescore",\cmd,\clear,\clef,l.clients.at(0).clef);

l.addClient(LSClient.forName("Soprano Saxophone")); 
l.clients.at(1).connect("192.168.1.108",57110);
l.clients.at(1).addr.sendMsg("/livescore",\cmd,\clear,\clef,l.clients.at(1).clef);

//You can also override the instrument ranges as follows
//instrument name, transposition=0, clef, lines(5), program (60), low, high, comfyLow, comfyHigh;
l.addClient(LSClient.new("Flute",0,LSClef.treble,5,74,59,96,60,93)); 
l.clients.at(0).connect("192.168.1.4",57110);
l.clients.at(0).addr.sendMsg("/livescore",\cmd,\clear,\clef,l.clients.at(0).clef);

//Start Server
l.start;

//Stop Server
l.stop;

//These are the variable for the notation
//see the function startMIDI in LiveScoreDifficult.sc to see how harris controlled these values from a Behringer BCR2000
l.fields;
l.numFields=10;
l.fieldSize=3;
l.densityCenter=1.9;
l.densityWidth=0.8;
l.durationCenter=0.3;
l.durationWidth=0.8;
l.togetherness=0.0;
l.fieldWidth=24; // 2-20
l.fieldCenter=65; // 60-70
l.generateFields;
l.quantize=0.0;
l.dynamic.put(2,2);
l.densityCenter

//This will make the dynamics work with different numbers of instruments/clients
l.dynamic = Array.fill(5,2);

//There are some other things you can set as well
l.clients.at(0).addr.sendMsg("/livescore",\cmd,\title,\title,"title",\titleSize,test);


